#include <iostream>
#include <string>
#include "doublell.h"

using namespace std;

// post: list printed along with output saying what the list should be
template <class T> void printTest(const DoubleLL<T>& list, std::string desired, int size)
{
  cout << "Should be " << desired << "; size = " << size << endl;
  
  if(list.size() != size)
  {
    cout << "TEST FAILED." << endl;
  }

  cout << endl;
}

int main()
{
  DoubleLL<std::string> list;
  DoubleLL<int> list2;

  // start with empty list?
  printTest<std::string>(list, std::string("()"), 0);
  list.insert(NULL, "precociously");
  printTest<std::string>(list, std::string("(precociously)"), 1);

  printTest<int>(list2, std::string("()"), 0);
  list2.insert(NULL, 1);
  printTest<int>(list2, std::string("(1)"), 1);

  return 0;
}
